helper = wesnoth.require "lua/helper.lua"
T = helper.set_wml_tag_metatable {}
 
local image_create_dialog = {
        
T.helptip { id="tooltip_large" }, 
T.tooltip { id="tooltip_large" }, 

T.grid { T.row { T.column {
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
T.grid {
      T.row {
		T.column {
			T.spacer { width = 1024 }			
                    },
		},
      T.row {
		T.column {
                border = "all", border_size = 5,
                vertical_alignment = "top",
                horizontal_alignment = "right",
                T.label {
                      definition = "title",
                      label = "~CROP(x,y,width,height)" ,
                        }
                    },
		},
      T.row {
           T.column {
--------------------------------------------------------
--------------------------------------------------------
--------------------------------------------------------
--------------------------------------------------------
T.grid {
	T.row {
		T.column {	T.spacer { width = 600 }	},
		T.column {	T.spacer { width = 400 }	},
		},
	T.row {
		T.column {
			horizontal_alignment = "center",
			horizontal_grow = false,
			border = "all", border_size = 5,
			T.label { 
				id = "image_size_label",
				label = "Image size: xxxx x xxxx"	}
				},	
		T.column {	T.spacer { }	},
		},
	T.row {
		T.column {
				horizontal_grow = true,
				vertical_grow = true,
				T.image { id = "image"	}
				},
 		T.column {	
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
T.grid {
	T.row {
		T.column {
			horizontal_alignment = "center",
			border = "all", border_size = 5,
			T.label { label = "Preview Mode"	}
				},
		},
	T.row {
		T.column {
--------------------------------------------------------
T.toggle_panel { T.grid { T.row {

T.column { 
horizontal_alignment = "left", border = "all", border_size = 5, 

T.horizontal_listbox { id = "multiplier_checkbox", 

T.list_definition { T.row { T.column { T.toggle_button { id = "multiplier_radiobutton" } } } },
                                                                                   T.list_data {
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "crop" } },
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "mask"} },
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "frame"} },
                                         
T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "zoom"} },
                                                                                                                                                                                              
             } 
				}
		},
}}}
--------------------------------------------------------
				},
		},
	T.row {
		T.column {
-------------------------------------------------------
T.grid {
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "left",
				label = "<",
				    }
				},
		T.column {
------------------------------=========================
T.grid {
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "up",
				label = "up",
				    }
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "down",
				label = "down",
				    }
				},
		},
}
-----------------------------==========================
				},
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "right",
				label = ">",
				    }
				},
		},
	},
-------------------------------------------------------
				},
		},
	T.row {
		T.column {
---------------------------==============================
T.grid {
	T.row {
		T.column {
			horizontal_alignment = "center",
			border = "all", border_size = 5,
			T.label { label = "Multiplier"	}
				},
		},
	T.row {
		T.column {
T.spacer { width = 290 }
				},
		},
}
---------------------------==============================
				},
		},
	T.row {
		T.column {
--------------------------------------------------------
--------------------------------------------------------
T.grid { T.row { T.column {
T.toggle_panel { T.grid { T.row {

T.column { 
horizontal_alignment = "left", border = "all", border_size = 5, 

T.horizontal_listbox { id = "multiplier_checkbox", 

T.list_definition { T.row { T.column { T.toggle_button { id = "multiplier_radiobutton" } } } },
                                                                                   T.list_data {
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "x1" } },
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "x3"} },
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "x5"} },
                                                                                                 T.row { horizontal_alignment = "left", border = "all", border_size = 5, T.column { label = "x10"} },
                                                                                                 
             } 
				}
		},
}}}
--------------------------------------------------------
				},
}}
--------------------------------------------------------
--------------------------------------------------------
				},
		},
	T.row {
		T.column {
--------------------------------------------------------
T.grid {
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "zoom_in",
				label = "ZOOM IN",
				    }
				},
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "mask_h_larger",
				label = "MASK Height +",
				    }
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "zoom_out",
				label = "ZOOM OUT",
				    }
				},
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "mask_h_smaller",
				label = "MASK Height -",
				    }
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "mask_width_smaller",
				label = "MASK Width -",
				    }
				},
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "mask_w_larger",
				label = "MASK Width +",
				    }
				},
		},
}}
---------------------------------------------------------
				},
	},
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
				},
		},
	},
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------
                    },
            },
	T.row {
		T.column {
--------------------------------------------------------
--------------------------------------------------------
T.grid {
	T.row {
		T.column {	T.spacer { }	},
		T.column {	T.spacer { width = 1000 }	},
		},
	T.row {
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 5,
				T.label { label = "Original Image:"	}
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 5,
				T.text_box { id = "source",	}
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "crop_image",
				label = "~CROP()",
				    }
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 5,
				T.text_box { id = "crop",	}
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "mask_image",
				label = "~MASK()",
				    }
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 5,
				T.text_box { id = "mask",	}
				},
		},
},
---------------------------------------------------------
---------------------------------------------------------
				},
		},
	T.row {
		T.column {
---------------------------------------------------------
T.grid {
	T.row {
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 0,
				T.label { label = "~CROP("	}
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 0,
				T.text_box { id = "crop_x",	}
				},
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 0,
				T.label { label = ","	}
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 0,
				T.text_box { id = "crop_y",	}
				},
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 0,
				T.label { label = ","	}
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 0,
				T.text_box { id = "crop_x_width",	}
				},
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 0,
				T.label { label = ","	}
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 0,
				T.text_box { id = "crop_y_width",	}
				},
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 0,
				T.label { label = ")"	}
				},
		},
	},
---------------------------------------------------------
				},
		},
	T.row {
		T.column {
--------------------------------------------------------
T.grid {
	T.row {
		T.column { T.spacer {} },
		T.column { T.spacer { width = 1000 } },
		},
	T.row {
		T.column {
				horizontal_grow = true,
				horizontal_alignment = "right",
				border = "all", border_size = 5,
				T.label { label = "Result Code:"	}
				},
		T.column {
				horizontal_grow = true,
				border = "all", border_size = 5,
				T.text_box { id = "result_code",	}
				},
		},
},
---------------------------------------------------------
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "cancel",
				label = "Close",
				    }
				},
		},
	T.row {
		T.column {
			border = "all", border_size = 5,
			T.button {
				id = "show_image",
				label = "Show Image",
				    }
				},
		},
	},
----------------------------------------------------------
----------------------------------------------------------
----------------------------------------------------------
----------------------------------------------------------
----------------------------------------------------------
}}}
}

local background ="misc/empty.png~SCALE(600,300)~BLIT(" 
local source = "portraits/monsters/ogre.png"
local source_position_x_text = ","
local source_position_x = "220"
local source_position_y_text = ")"
local source_position_y = "50"
local background_source_result = background .. source .. source_position_x_text .. source_position_x .. source_position_x_text .. source_position_y .. source_position_y_text
--local source = background_source_result 

local crop1 = "~BLIT(terrain/darken.png~CROP(12,12,48,48)~SCALE(100,100),5,5)"
local crop = ""
local mask = ""
local mask1 = "~MASK(icons/greaves.png~SCALE(72,72)~CROP(12,12,48,48)~SCALE(100,100),5,5)"

function wesnoth.calculate_source()
	local image_w, image_h = wesnoth.get_image_size(source)
source_position_x = (600 - image_w)/2
source_position_y = (300 - image_h)/2
background_source_result = background .. source .. source_position_x_text .. source_position_x .. source_position_x_text .. source_position_y .. source_position_y_text
end

function wesnoth.image_create()
---------------------------------
	local function do_show_image_mask()
wesnoth.calculate_source()
	source = wesnoth.get_dialog_value("source")
	mask = wesnoth.get_dialog_value("mask") 
	if (wesnoth.get_dialog_value("mask") == "") 
	then mask = mask1 end
	wesnoth.set_dialog_value(source, "source")
	--wesnoth.set_dialog_value(source, "image")
	wesnoth.set_dialog_value(mask, "mask")
	local image_w, image_h = wesnoth.get_image_size(source)
	wesnoth.set_dialog_value("Image size: " .. tostring(image_w) .. "x" .. tostring(image_h),"image_size_label")
	--wesnoth.set_dialog_value(source .. mask, "image")
	wesnoth.set_dialog_value(background_source_result .. mask, "image")
	wesnoth.set_dialog_value(source .. mask, "result_code")
	end
----------------------------------
	local function do_show_image_crop()
wesnoth.calculate_source()
	source = wesnoth.get_dialog_value("source")
	crop = wesnoth.get_dialog_value("crop") 
	if (wesnoth.get_dialog_value("crop") == "") 
	then crop = crop1 end
	wesnoth.set_dialog_value(source, "source")
	--wesnoth.set_dialog_value(source, "image")
	wesnoth.set_dialog_value(crop, "crop")
	local image_w, image_h = wesnoth.get_image_size(source)
	wesnoth.set_dialog_value("Image size: " .. tostring(image_w) .. "x" .. tostring(image_h),"image_size_label")
	--wesnoth.set_dialog_value(source .. crop, "image")
	wesnoth.set_dialog_value(background_source_result .. crop, "image")
	wesnoth.set_dialog_value(source .. crop, "result_code")
	end
--------------------------------------
	local function do_clear()
	end
	local function do_preview()
	end
-------------------------------------------------------------
-------------------------------------------------------------
	local function preshow()
---------------------------------------------------------------
	wesnoth.set_dialog_callback(do_show_image_mask, "mask_image")
	wesnoth.set_dialog_callback(do_show_image_crop, "crop_image")
---------------------------------------------------------------
wesnoth.calculate_source()
---------------------------------------------------------------
	if not (wesnoth.get_dialog_value("source") == "") 
	then source = wesnoth.get_dialog_value("source") end
	crop = wesnoth.get_dialog_value("crop") 
	if (wesnoth.get_dialog_value("crop") == "") 
	then crop = crop1 end
	mask = wesnoth.get_dialog_value("mask") 
	if (wesnoth.get_dialog_value("mask") == "") 
	then mask = mask1 end
	wesnoth.set_dialog_value(source, "source")
	--wesnoth.set_dialog_value(source, "image")
	wesnoth.set_dialog_value(mask, "mask")
	wesnoth.set_dialog_value(crop, "crop")
	local image_w, image_h = wesnoth.get_image_size(source)
	wesnoth.set_dialog_value("Image size: " .. tostring(image_w) .. "x" .. tostring(image_h),"image_size_label")
	--wesnoth.set_dialog_value(source .. crop, "image")
	wesnoth.set_dialog_value(background_source_result .. crop, "image")
	wesnoth.set_dialog_value(source .. crop, "result_code")
	end
---------------------------------------------------------------
---------------------------------------------------------------
	local function postshow()
	end
	local res
	repeat
	res = wesnoth.show_dialog(image_create_dialog, preshow,do_show_image_crop)
	until res ~= -1
	end